commit 6b3239418fb0e62ba3f6a5864d24a6dfc1d81972
Author: Varun Nagaraju <varun.nagaraju@percona.com>
Date:   Wed Oct 30 15:28:03 2024 +0530

    PS-9434 database() results truncated at 34 bytes due to union
    
    https://perconadev.atlassian.net/browse/PS-9434
    
    Bug#36871927 mysql/mysql-server@2dd5e2ededb
    
    The results are truncated because the metadata for function DATABASE()
    indicates a string with maximum length 34 characters. This happens
    because the length is taken from the constant value MAX_FIELD_NAME
    instead of the correct NAME_CHAR_LEN (which gives the maximum length
    of a typical identifier in the data dictionary).
    
    The fix is to replace the wrong constant value.
    In addition, the constant MAX_FIELD_NAME is removed since it is
    basically unused. The only other use (in check_if_keyname_exists() to
    synthesize a key name) is replaced with a value that makes the index
    name use up to 64 single-byte characters, including underscore and
    a generated two-digit sequence number.
    
    Change-Id: I94b6327d0b8e867c9776afe3e68dd0e0ab83a939

diff --git a/mysql-test/r/func_system.result b/mysql-test/r/func_system.result
index dde41c99345..9c60da65f19 100644
--- a/mysql-test/r/func_system.result
+++ b/mysql-test/r/func_system.result
@@ -50,7 +50,7 @@ create table t1 (version char(60)) select database(), user(), version() as 'vers
 show create table t1;
 Table	Create Table
 t1	CREATE TABLE `t1` (
-  `database()` varchar(34) CHARACTER SET utf8 DEFAULT NULL,
+  `database()` varchar(64) CHARACTER SET utf8 DEFAULT NULL,
   `user()` varchar(93) CHARACTER SET utf8 NOT NULL DEFAULT '',
   `version` char(60) DEFAULT NULL
 ) ENGINE=ENGINE DEFAULT CHARSET=latin1
@@ -100,3 +100,24 @@ select left(concat(a,version()),1) from t1;
 left(concat(a,version()),1)
 a
 drop table t1;
+#
+# Bug#36871927: database() results truncated at 34 bytes due to union
+#
+CREATE DATABASE
+db345678901234567890123456789012345678901234567890123456789012345;
+ERROR 42000: Identifier name 'db345678901234567890123456789012345678901234567890123456789012345' is too long
+CREATE DATABASE
+db34567890123456789012345678901234567890123456789012345678901234;
+USE db34567890123456789012345678901234567890123456789012345678901234;
+SELECT DATABASE();
+DATABASE()
+db34567890123456789012345678901234567890123456789012345678901234
+SELECT DATABASE() UNION SELECT DATABASE();
+DATABASE()
+db34567890123456789012345678901234567890123456789012345678901234
+SELECT DATABASE() UNION ALL SELECT DATABASE();
+DATABASE()
+db34567890123456789012345678901234567890123456789012345678901234
+db34567890123456789012345678901234567890123456789012345678901234
+USE test;
+DROP DATABASE db34567890123456789012345678901234567890123456789012345678901234;
diff --git a/mysql-test/t/func_system.test b/mysql-test/t/func_system.test
index bdad2f78352..d5170ac7bff 100644
--- a/mysql-test/t/func_system.test
+++ b/mysql-test/t/func_system.test
@@ -65,3 +65,18 @@ select left(concat(a,version()),1) from t1;
 drop table t1;
 
 # End of 4.1 tests
+
+--echo #
+--echo # Bug#36871927: database() results truncated at 34 bytes due to union
+--echo #
+--error ER_TOO_LONG_IDENT
+CREATE DATABASE
+db345678901234567890123456789012345678901234567890123456789012345;
+CREATE DATABASE
+db34567890123456789012345678901234567890123456789012345678901234;
+USE db34567890123456789012345678901234567890123456789012345678901234;
+SELECT DATABASE();
+SELECT DATABASE() UNION SELECT DATABASE();
+SELECT DATABASE() UNION ALL SELECT DATABASE();
+USE test;
+DROP DATABASE db34567890123456789012345678901234567890123456789012345678901234;
diff --git a/sql/item_strfunc.h b/sql/item_strfunc.h
index d0342d3a7fb..5c07445b4cf 100644
--- a/sql/item_strfunc.h
+++ b/sql/item_strfunc.h
@@ -1,7 +1,7 @@
 #ifndef ITEM_STRFUNC_INCLUDED
 #define ITEM_STRFUNC_INCLUDED
 
-/* Copyright (c) 2000, 2023, Oracle and/or its affiliates.
+/* Copyright (c) 2000, 2024, Oracle and/or its affiliates.
 
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2.0,
@@ -654,7 +654,7 @@ public:
   String *val_str(String *);
   void fix_length_and_dec()
   {
-    max_length= MAX_FIELD_NAME * system_charset_info->mbmaxlen;
+    max_length= NAME_CHAR_LEN * system_charset_info->mbmaxlen;
     maybe_null=1;
   }
   const char *func_name() const { return "database"; }
diff --git a/sql/sql_const.h b/sql/sql_const.h
index f74c494bcfd..b25210cd8ce 100644
--- a/sql/sql_const.h
+++ b/sql/sql_const.h
@@ -1,4 +1,4 @@
-/* Copyright (c) 2006, 2023, Oracle and/or its affiliates.
+/* Copyright (c) 2006, 2024, Oracle and/or its affiliates.
 
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2.0,
@@ -34,7 +34,6 @@
 /* extra 4+4 bytes for slave tmp tables */
 #define MAX_DBKEY_LENGTH (NAME_LEN*2+1+1+4+4)
 #define MAX_ALIAS_NAME 256
-#define MAX_FIELD_NAME 34			/* Max colum name length +2 */
 #define MAX_SYS_VAR_LENGTH 32
 #define MAX_KEY MAX_INDEXES                     /* Max used keys */
 #define MAX_REF_PARTS 16U			/* Max parts used as ref */
diff --git a/sql/sql_table.cc b/sql/sql_table.cc
index e627b844de6..88835fc4efb 100644
--- a/sql/sql_table.cc
+++ b/sql/sql_table.cc
@@ -1,5 +1,5 @@
 /*
-   Copyright (c) 2000, 2023, Oracle and/or its affiliates.
+   Copyright (c) 2000, 2024, Oracle and/or its affiliates.
 
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2.0,
@@ -5850,16 +5850,18 @@ check_if_keyname_exists(const char *name, KEY *start, KEY *end)
 static char *
 make_unique_key_name(const char *field_name,KEY *start,KEY *end)
 {
-  char buff[MAX_FIELD_NAME],*buff_end;
+  // NOTE: This may not handle multi-byte characters properly
+  char buff[NAME_CHAR_LEN + 1];
 
   if (!check_if_keyname_exists(field_name,start,end) &&
       my_strcasecmp(system_charset_info,field_name,primary_key_name))
     return (char*) field_name;			// Use fieldname
-  buff_end=strmake(buff,field_name, sizeof(buff)-4);
+  // Reserve space for '_', two-digit sequence number and terminating null char:
+  char *buff_end = strmake(buff, field_name, sizeof(buff) - 4);
 
   /*
-    Only 3 chars + '\0' left, so need to limit to 2 digit
-    This is ok as we can't have more than 100 keys anyway
+    2 digits support up to 100 keys, which is more than the normal MAX_INDEXES
+    limit (64).
   */
   for (uint i=2 ; i< 100; i++)
   {

